stages:
  - build
  - deploy

variables:
  MAVEN_CLI_OPTS: "-s .ci/settings.xml --batch-mode"
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository"

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .m2/repository/

build:
  stage: build
  image: registry.gitlab.com/tinymediamanager/docker/packaging:20220601182613
  environment:
    name: nightly
    url: https://nightly.tinymediamanager.org
  allow_failure: false
  tags:
    - tmm # force running on own runners
  script:
    # just run on changes from the last 24 hrs
    # does not work at the moment since we cannot abort subsequent jobs
    # if [ "$NIGHTLY_BUILD_FORCE" = "false" ] && [ $(git rev-list --after="24 hours" --count "$CI_COMMIT_SHA") -eq 0 ]; then exit 0; fi

    # generate changelog.txt for nightly builds
    - sh generate_changelog.sh

    # package archives
    - mvn $MAVEN_CLI_OPTS -P gitlab-ci -P dist -DbuildNumber=${CI_COMMIT_SHORT_SHA} -Dgetdown=getdown-nightly.txt -Dnightly=true -Dthread_pool_size=1 clean package

    # build windows installer
    - chmod 777 . dist
    - sudo -u xclient PATH=$PATH:/opt/bin AppBundler/create_windows_installer.sh

    # build macOS dmg file
    - sh AppBundler/create_dmg.sh

    # push the build to the webserver
    - lftp -c "set ftp:ssl-allow no; open -u ${FTP_USER_NIGHTLY},${FTP_PASSWORD_NIGHTLY} ${FTP_HOST}; mirror -Rev build/ ./upload/v4/build; mirror -Rev dist/ ./upload/v4/dist; chmod -R g+w ./upload/v4"

    # and publish the files on the webserver
    - curl https://nightly.tinymediamanager.org/${PUBLISH_ENDPOINT_V4}
    - curl https://nightly.tinymediamanager.org/${CREATE_INDEX}
    - curl https://nightly.tinymediamanager.org/${CREATE_INDEX_V4}

  artifacts:
    expire_in: 2 days
    paths:
      - dist/tmm*linux-amd64.tar.gz # upload for docker build

deploy-docker:
  stage: deploy
  image: docker:latest
  services:
    - name: docker:dind
  needs:
    - build
  variables:
    IMAGE_NAME: tinymediamanager/tinymediamanager:4-nightly
  script:
    # login
    - docker login -u $DOCKERHUB_USERNAME -p $DOCKERHUB_PASSWORD

    # build
    - tar xzf dist/tmm*linux-amd64.tar.gz -C docker/
    - cd docker
    - docker build -f Dockerfile.nightly -t $IMAGE_NAME .

    # push to the registry
    - docker push $IMAGE_NAME
